//
//  ShogibanDocument.m
//  Shogiban2
//
//  Created by KOYAMA Yoshiaki on Sun Aug 10 2003.
//  Copyright (c) 2003 KOYAMA Yoshiaki. All rights reserved.
//

#import "ShogibanDocument.h"
#import "ShogibanWindowController.h"
#import "YKifController.h"

@implementation ShogibanDocument

- (id)init {
    self = [super init];
    if (self) {
    }
    return self;
}

- (NSString *)windowNibName {
    return @"ShogibanDocument";
}

- (void)makeWindowControllers {
    ShogibanWindowController *controller = [[ShogibanWindowController alloc] init];
    [self addWindowController:controller];
    [controller release];
}

- (void)windowControllerDidLoadNib:(NSWindowController *) aController {
    ShogibanWindowController *controller;
    YKifController *ykifController;

    [super windowControllerDidLoadNib:aController];

    controller = [[self windowControllers] objectAtIndex:0];
    ykifController = [controller ykifController];
 
    if (_type != nil) {
        [ykifController doOpen:_data :_type];
    }

/*   if ([ykifController gameSenteName] == nil) {
        [aController showWindow:self];
        [ykifController newKif];        
    }
*/
}

- (NSData *)dataRepresentationOfType:(NSString *)aType {
    ShogibanWindowController *controller;
    YKifController *ykifController;

    controller = [[self windowControllers] objectAtIndex:0];
    ykifController = [controller ykifController];
 
    if (aType != nil) {
        return [ykifController doSave];
    }
        
    return nil;
}

- (BOOL)loadDataRepresentation:(NSData *)data ofType:(NSString *)aType {
    _data = [data retain];
    _type = [aType retain];

    return YES;
}

// p΋
- (IBAction)editDocument:(id)sender {
    ShogibanWindowController *controller;
    YKifController *ykifController;

    controller = [[self windowControllers] objectAtIndex:0];
    ykifController = [controller ykifController];

	[self updateChangeCount:NSChangeDone];
 
    [ykifController editKif];
}

// fǖʂĊJ
- (IBAction)editEndDocument:(id)sender {
    ShogibanWindowController *controller;
    YKifController *ykifController;

    controller = [[self windowControllers] objectAtIndex:0];
    ykifController = [controller ykifController];

	[self updateChangeCount:NSChangeDone]; 

    [ykifController editEndKif];

}

// fobO
- (IBAction)printKifDocument:(id)sender {
    ShogibanWindowController *controller;
    YKifController *ykifController;

    controller = [[self windowControllers] objectAtIndex:0];
    ykifController = [controller ykifController];
 
    [ykifController printKifController];
}

// j[̏B
- (BOOL)validateMenuItem:(NSMenuItem *)anItem {
    ShogibanWindowController *controller;
    YKifController *ykifController;

    controller = [[self windowControllers] objectAtIndex:0];
    ykifController = [controller ykifController];
 
    return [ykifController validateMenuItem:anItem :_type];

    return YES;
}

@end
